<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/css/bootstrap.min.css" crossorigin="anonymous">
    <title>GP2 Compiler</title>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom box-shadow p-3 px-md-4 mb-3">
        <a class="navbar-brand" href="#">GP2</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarText" aria-controls="navbarText" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarText">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item">
                    <a class="nav-link" href="/">Interpreter</a>
                </li>
                <li class="nav-item active">
                    <a class="nav-link" href="/source">Compiler</a>
                </li>
            </ul>
            <a class="btn btn-outline-primary" href="https://gitlab.com/YorkCS/Batman/GP2-HTTP" target="_blank">GitLab</a>
        </div>
    </nav>
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm">
                <div class="form-group">
                    <label for="gp2Program"><strong>GP2 Program</strong></label>
                    <textarea class="form-control" id="gp2Program" rows="16"></textarea>
                </div>
            </div>
        </div>
        <hr>
        <div class="row" id="resultArea">
        </div>
    </div>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.1/umd/popper.min.js" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/js/bootstrap.min.js" crossorigin="anonymous"></script>
    <script type="text/javascript">
        $(function() {
            function renderCode(files) {
                var str = '<div class="col-sm">';

                $.each(files, function (k, v) {
                    str += '<div class="form-group"><label for="outputCode"><strong>' 
                        + k + '</strong></label><textarea readonly class="form-control" id="outputCode" rows="16">'
                        + v + '</textarea></div>'
                });

                str += '</div>';

                return str;
            }

            function renderError(err) {
                var es = err.split("\n");
                var result = '<p class="lead">' + es.shift() + '</p>';

                es.forEach(function(e) {
                    result += '<p>' + e + '</p>';
                });

                return '<div class="col-sm">' + result + '</div>';
            }

            function performCompile(program) {
                $.ajax({
                    url : '/compile',
                    data : JSON.stringify({program: program}),
                    contentType : 'application/json',
                    type : 'POST',
                })
                .done(function(response) {
                    $("#resultArea").html(renderCode(response.files));
                })
                .fail(function(response) {
                    try {
                        $("#resultArea").html(renderError(response.responseJSON.error));
                    } catch (e) {
                        $("#resultArea").html(renderError('Unable to communicate with server.'));
                    }
                });
            }

            var oldProgram = "";
            $("#gp2Program").on("change keyup paste", function() {
                var program = $(this).val();
                if (program == oldProgram) {
                    return;
                }

                oldProgram = program;
                performCompile(program);
            });
        });
    </script>
</body>
</html>
